from model import net,criterion,optimizer
import torch
from torch.autograd import Variable
from torch.utils.data import DataLoader
import cv2 as cv
import torchvision.transforms as transforms
from PIL import Image
from download import classes



net.load_state_dict(torch.load('./weights'))

net.eval()

imsize = (32,32)

transform = transforms.Compose(
    [transforms.Resize(imsize),
    transforms.ToTensor(),
     transforms.Normalize((0.5, 0.5, 0.5), (0.5, 0.5, 0.5))])


def image_loader(image_name):
    """load image, returns cuda tensor"""
    image = Image.open(image_name)
    image = transform(image).float()
    image = Variable(image, requires_grad=True)
    image = image.unsqueeze(0)  #this is for VGG, may not be needed for ResNet
    # return image.cuda()  #assumes that you're using GPU
    return image

image = image_loader('test_2.jpg')

res = net(image)

index = res.data.numpy().argmax()
print(classes[index])
